<?php 
/**
* This class builds video ad options
*/
class PmillVideoAdOptions
{
	public $videoAdOptions;

	public function __construct($videoAdOptions)
	{
		$this->videoAdOptions = $videoAdOptions;
	}

	function pm_videoad_options() {
		if( !empty( $this->videoAdOptions ) ) {
		foreach ($this->videoAdOptions as $video_key => $video) {
			$video_key = ( !empty( $video_key ) ) ? $video_key : '' ;
			$id = ( empty( $video_key ) ) ? $video['count'] : $video_key ;
			$optkey = ( empty( $video['optkey'] ) ) ? 'videos' : sanitize_text_field( $video['optkey'] ) ;
			$videoname = ( empty($video['videoname']) ) ? '' : sanitize_text_field( $video['videoname'] ) ;
			$ytvdoid = ( empty($video['ytvdoid']) ) ? '' : stripslashes( $video['ytvdoid'] ) ;
			$controls = ( empty($video['controls']) ) ? '0' : '2' ;
			$autoplay = ( empty($video['autoplay']) ) ? '0' : '1' ;
			$focusplay = ( empty($video['focusplay']) ) ? '0' : '1' ;
			$pausetext = ( empty($video['pausetext']) ) ? '' : stripslashes( $video['pausetext'] ) ;
			$endtext = ( empty($video['endtext']) ) ? '' : stripslashes( $video['endtext'] ) ;
			$endscreen = ( empty($video['endscreen']) ) ? '' : stripslashes( $video['endscreen'] ) ;
			$custom_css = ( empty($video['custom_css']) ) ? '' : stripslashes( $video['custom_css'] ) ;
		?>
		<div id="video-<?php echo $id; ?>" class="added_video" data-id="<?php echo $id; ?>">
		<h3>
			Video #<?php echo $id; ?> <a class="remove_video">Remove</a>
		</h3>
		<div><table>
			<tr>
				<th>Video name</th>
				<td>
					<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][videoname]" id="videoname-<?php echo $id; ?>" class="videoname regular-text" value="<?php echo $videoname;?>"><br>
					<small>For admin reference only.</small>
				</td>
			</tr>
			<tr>
				<th>Youtube video ID</th>
				<td>
					<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][ytvdoid]" id="ytvdoid-<?php echo $id; ?>" class="ytvdoid regular-text" data-ytvdoidkey="<?php echo $id; ?>" value="<?php echo $ytvdoid;?>">
					<div id="ytvideo-<?php echo $video_key; ?>">
					<?php if( !empty( $ytvdoid ) ) { ?>
						<iframe width="560" height="315" src="//www.youtube.com/embed/<?php echo $ytvdoid; ?>" frameborder="0" allowfullscreen></iframe>
					<?php } ?>
					</div>
				</td>
			</tr>
			<tr>
				<th>Ad messages<br><small>Basic HTML in messages accepted</small></th>
				<td>
					<table id="repeatable_message_fields_<?php echo $video_key; ?>" class="repeatable-message-fields">
						<thead>
							<tr>
								<th>Ad text/message</th>
								<th>Show from this time (secs)</th>
								<th>To this time (secs)</th>
							</tr>
						</thead>
						<tbody>
						<?php if(empty($video['messages'])) { ?>
							<tr>
								<td>
									<textarea name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][adtext][]" id="adtext" cols="30" rows="5"></textarea>
								</td>
								<td>
									<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][fromtime][]">
								</td>
								<td>
									<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][totime][]">
								</td>
								<td>
									<span class="button remove-message-row">Remove</span> 
								</td>
							</tr>
							<?php } else {
								foreach ($video['messages'] as $message_key => $message) {
									?>
									<tr>
										<td>
											<textarea name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][adtext][]" id="adtext" cols="30" rows="5"><?php echo stripslashes($message['adtext']); ?></textarea>
										</td>
										<td>
											<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][fromtime][]" value="<?php echo stripslashes( $message['fromtime'] ); ?>">
										</td>
										<td>
											<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][totime][]" value="<?php echo stripslashes( $message['totime'] ); ?>">
										</td>
										<td>
											<span class="button remove-message-row">Remove</span> 
										</td>
									</tr>
									<?php
								}
								} ?>
						</tbody>
					</table>
					<p>
						<?php $message_count = count($video['messages']); ?>
						<a class="button add-message-row" data-message-count="<?php echo $message_count; ?>" data-video-key="<?php echo $video_key; ?>">Add Another</a>
					</p>
					<table id="additional-messages">
						<thead>
							<tr>
								<th>Ad text/message when video is paused</th>
								<th>Ad text/Message when video has ended</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td>
									<textarea name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][pausetext]" id="pausetext" cols="30" rows="5"><?php echo $pausetext; ?></textarea>
								</td>
								<td>
									<textarea name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][endtext]" id="endtext" cols="30" rows="5"><?php echo $endtext; ?></textarea>
								</td>
							</tr>
						</tbody>
					</table>
				</td>
			</tr>
			<tr>
				<th>End screen</th>
				<td>
					<textarea name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][endscreen]" id="endscreen" cols="60" rows="3"><?php echo $endscreen; ?></textarea><br>
					<small>Replace video at the end with this. Basic HTML accepted.</small>
				</td>
			</tr>		
			<tr>
				<th>Display player controls</th>
				<td>
					<label class="checkbox" for="controls-<?php echo $id; ?>">
					<input type="checkbox" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][controls]" value="2" id="controls-<?php echo $id; ?>" <?php checked( $controls, '2' ); ?>>
						Yes</label>
				</td>
			</tr>
			<tr>
				<th>Autoplay</th>
				<td>
					<label class="checkbox" for="autoplay-<?php echo $id; ?>">
					<input type="checkbox" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][autoplay]" value="1" id="autoplay-<?php echo $id; ?>" <?php checked( $autoplay, '1' ); ?>>
						Yes</label>
				</td>
			</tr>
			<tr>
				<th>Pause when user clicks away</th>
				<td>
					<label class="checkbox" for="focusplay-<?php echo $id; ?>">
					<input type="checkbox" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][focusplay]" value="1" id="focusplay-<?php echo $id; ?>" <?php checked( $focusplay, '1' ); ?>>
						Yes</label><br><small>When user clicks to another application or tab, video will pause.</small>
				</td>
			</tr>
			<tr id="empty-message-row-<?php echo $video_key; ?>" class="empty-msg-row">
				<td>
					<textarea name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][adtext][]" id="adtext" cols="30" rows="5"></textarea>
				</td>
				<td>
					<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][fromtime][]">
				</td>
				<td>
					<input type="text" name="pm_vat_options[<?php echo $optkey; ?>][<?php echo $video_key; ?>][messages][totime][]">
				</td>
				<td>
					<span class="button remove-message-row">Remove</span> 
				</td>
			</tr>
		</table>
		</div>
		</div>
		<?php
		}
	}
	}
}
?>