<?php
/*
 * Add buttons to visual editor
 */
function pm_vat_tmcebuttons($post) {
	
	// Don't bother if current user doesn't have permissions
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;
	
	// Add only in rich editor mode
	if( get_user_option( 'rich_editing' ) == 'true' ) {
		$current_screen = get_current_screen();
		$current_screen = $current_screen->base;
           
		if( $current_screen == 'post' ) {
			add_filter('mce_external_plugins', 'pm_vat_buttons_mce_plugin');
			add_filter( 'mce_buttons', 'pm_vat_add_tmce_buttons' );
		}
	}
}

function pm_vat_add_tmce_buttons( $buttons ) {
    array_push( $buttons, '|', 'pmvatbuttons' );
    return $buttons;
}
add_action( 'admin_head', 'pm_vat_tmcebuttons' );

/*
 * Bring in button
 */
function pm_vat_buttons_mce_plugin( $plugins ) {
	$wpversion = get_bloginfo( 'version' );
	// this plugin file will work the magic of our button
	$plugins['pmvatbuttons'] = PM_VAT_DIR . 'modules/js/pm-vat-dialog.js';

	return $plugins;
}

// Localize script for TinyMCE editor use
add_action( 'before_wp_tiny_mce', 'pm_vat_localize_for_tinymce' );
function pm_vat_localize_for_tinymce( $hook ) {
	$current_screen = get_current_screen();
	$current_screen = $current_screen->base;

	if( $current_screen == 'post' || $current_screen == 'page' ) {
		global $post;
		$params = array(
			'nonce' => wp_create_nonce('pm_vat_options'),
			'is_admin' => is_admin(),
			'pid' => $post->ID,
			'pm_vat_dir' => PM_VAT_DIR,
			'pm_vat_plugin_name' => PM_VAT_PLUGIN_NAME
		);
		?>
		<script type='text/javascript'>
		/* <![CDATA[ */
		var pm_vat_object = <?php echo json_encode( $params ); ?>;
		/* ]]> */
		</script>
		<?php
	}
}
// Hook in TinyMCE dialog
add_action ( 'admin_footer', 'pm_vat_main_editor_dialog' );
function pm_vat_main_editor_dialog() {
	$pm_vat_options = get_option('pm_vat_options');
	$videos = ( !empty($pm_vat_options['videos'] ) ) ? $pm_vat_options['videos'] : '' ;
	global $post;
	$currScreen = get_current_screen();
	if( $currScreen -> base == 'post' ) {
		?>
		<div id="pm_vat_editor_dialog" class="dialog" style="display: none; margin-bottom: 15px;">
			<div id="pm-vat-dialog-response"></div>
			<div>
				Select a video to add:
				<select name="pm_vat_select_video" id="pm_vat_video_selector">
					<option value="0">None</option>
					<?php
					if( !empty( $videos ) ) {
						foreach ($videos as $video_key => $video) {
							?>
							<option value="<?php echo $video_key; ?>"><?php echo $video['videoname']; ?></option>
							<?php
						}
					}
					?>
				</select>
				<input type="hidden" name="pm_vat_postid" value="<?php echo $post->ID; ?>">
			</div>
			<p style="text-align: center;"><button id="pm-vat-insert" class="button-primary">Insert Into Editor</button></p>
		</div>
		<script>
		jQuery(document).ready( function($){
			$('#pm-vat-insert').on('click', function(e) {
			e.preventDefault();
			//var created_img = $('#spp-isim-created-img-preview').html();
			var selected_video = $('#pm_vat_video_selector :selected').val();
			var content = tinymce.activeEditor.selection.getContent();
			if( selected_video == '0') {				
				// None selected
				$("#pm-vat-dialog-response").html('No video selected').addClass('error notice');
			} else {
				var videoshortcode = '[pmill_vat vid="' + selected_video + '"]';
			}

			tinymce.activeEditor.execCommand('mceInsertContent', false, videoshortcode);
			top.tinymce.activeEditor.windowManager.close();
		});
		}); // global end
		</script>
		<?php	
	}
}
?>