<?php 
add_shortcode( 'pmill_vat', 'pm_vat_shortcode_process' );
function pm_vat_shortcode_process( $atts, $content = null ) {
	extract( shortcode_atts( array(
		'vid' => '',
	), $atts ) );
	$site_domain = parse_url( get_bloginfo( 'url' ) );
	$vid = stripslashes($vid);

	wp_enqueue_style( 'pm_vat_front', PM_VAT_DIR.'modules/css/front.css', '', false, 'all' );

	// Ad box styles variable
	$pm_vat_options = get_option( 'pm_vat_options' );
	$border_color = ( empty( $pm_vat_options['stylearray']['border_color'] ) ) ? '' : 'border-color:'.stripslashes( $pm_vat_options['stylearray']['border_color'] ).';' ;
	$border_width = ( empty( $pm_vat_options['stylearray']['border_width'] ) ) ? '' : 'border-width:'.stripslashes( $pm_vat_options['stylearray']['border_width'] ).'px;' ;
	$border_style = ( empty( $pm_vat_options['stylearray']['border_style'] ) ) ? '' : 'border-style:'.stripslashes( $pm_vat_options['stylearray']['border_style'] ).';' ;
	$background_color = ( empty( $pm_vat_options['stylearray']['background_color'] ) ) ? '' : 'background-color:'.stripslashes( $pm_vat_options['stylearray']['background_color'] ).';' ;
	$font_color = ( empty( $pm_vat_options['stylearray']['font_color'] ) ) ? '' : 'color:'.stripslashes( $pm_vat_options['stylearray']['font_color'] ).';' ;
	$font_size = ( empty( $pm_vat_options['stylearray']['font_size'] ) ) ? '' : 'font-size:'.stripslashes( $pm_vat_options['stylearray']['font_size'] ).'px;' ;
	
	$adboxstyles = $border_width.$border_style.$border_color.$background_color.$font_color.$font_size;
	// Output Youtube javascript to footer
	add_action('wp_footer', function() use($vid, $site_domain) {		
		$pm_vat_options = get_option( 'pm_vat_options' );
		$videos = $pm_vat_options['videos'];
		wp_enqueue_script( 'pm_vat_yt_iframe_api', '//www.youtube.com/iframe_api', array('jquery'), null, false );
		?>
		<script>
		var player;
		function onYouTubeIframeAPIReady() {
		    player = new YT.Player("<?php echo 'pm-vat-video-'.$vid; ?>", {
		        videoId: "<?php echo stripslashes($videos[$vid]['ytvdoid']); ?>",
		        playerVars: {
		            controls: "<?php echo stripslashes($videos[$vid]['controls']); ?>",
		            autoplay: "<?php echo stripslashes($videos[$vid]['autoplay']); ?>",
		            disablekb: 0,
		            enablejsapi: 1,
		            iv_load_policy: 1,
		            modestbranding: 1,
		            showinfo: 0,
		            origin: "<?php echo $site_domain['host']; ?>",
		            playsinline: 1,
		            showinfo: 1,
		        },
		        events: {
		        	//'onReady': onReady,
		        	'onStateChange' : onStateChange
		        }
		    });
		}
		var overlays = [
		<?php foreach ($videos[$vid]['messages'] as $message) {
			echo '{text:"'.stripslashes($message['adtext']).'",from:"'.stripslashes($message['fromtime']).'",to:"'.stripslashes($message['totime']).'"},';
		} ?>];

		var watchId;
		function startWatch() {
			watchId = setInterval( function() {
				showOrHideOverlay(player.getCurrentTime());
			}, 1000)
		}

		function stopWatch() {
			clearTimeout(watchId);
		}
		function onReady(event) {
			event.target.mute();
		}
		function onStateChange(newState) {
			if(newState.data == 1) { //playing
				startWatch()
			}
			else if(newState.data == 2) { //video paused
				<?php if( !empty( $videos[$vid]['pausetext'] ) ) { ?>
				stopWatch();
				jQuery('#pm-vat-ad-<?php echo $vid; ?>').show();
				jQuery('#pm-vat-ad-<?php echo $vid; ?>').html("<?php echo stripslashes($videos[$vid]['pausetext']); ?>");
				<?php } ?>
			} else if(newState.data == 0 || newState.data == 5) { // video ended or cued
				jQuery('#pm-vat-ad-<?php echo $vid; ?>').show().html("<?php echo stripslashes($videos[$vid]['endtext']); ?>");
				<?php if( !empty( $videos[$vid]['endscreen'] ) ) { ?>
				jQuery('#pm-vat-video-<?php echo $vid; ?>').hide();
				jQuery('#pm-vat-endscreen-<?php echo $vid; ?>').show().html("<?php echo stripslashes($videos[$vid]['endscreen']); ?>");
				<?php } ?>
			}
		}
		function showOrHideOverlay(time) {
			// Find text that should be displayed
			var shownOverlays = false;
			for(var i=0; i<overlays.length; i++) {
				if(overlays[i].from < time && overlays[i].to > time) {
					jQuery('#pm-vat-ad-<?php echo $vid; ?>').show();
					jQuery('#pm-vat-ad-<?php echo $vid; ?>').html(overlays[i].text);
					shownOverlays = true;
				}
			}
			if(!shownOverlays)
				jQuery('#pm-vat-ad-<?php echo $vid; ?>').html("").css('display', '');
		}
		<?php if( $videos[$vid]['focusplay'] == 1 ) {
			pm_vat_focusplay_detect();
		} ?>
		</script>
		<?php
	}); // End wp_footer action

	return <<<HTML
	<div id="pm-vat-container-{$vid}" class="pm-vat-containers">
		<div id="pm-vat-video-{$vid}" class="pm-vat-video"></div>
		<div id="pm-vat-endscreen-{$vid}" class="pm-endscreens"></div>
		<div id="pm-vat-ad-{$vid}" class="pm-vat-ad-msg" style="$adboxstyles"></div>
	</div>
HTML;
}

function pm_vat_focusplay_detect() {
	?>
	// Is user still on tab?
		var vis = (function(){
		    var stateKey, eventKey, keys = {
		        hidden: "visibilitychange",
		        webkitHidden: "webkitvisibilitychange",
		        mozHidden: "mozvisibilitychange",
		        msHidden: "msvisibilitychange"
		    };
		    for (stateKey in keys) {
		        if (stateKey in document) {
		            eventKey = keys[stateKey];
		            break;
		        }
		    }
		    return function(c) {
		        if (c) document.addEventListener(eventKey, c);
		        return !document[stateKey];
		    }
		})();
		var visible = vis(); // get current visibility
		vis(function() {
			if(vis() == true && player.getPlayerState() != 1 ) {
				player.playVideo();
			}
			if(vis() == false) {
				player.pauseVideo();
			}
		});
	<?php
}
?>